// UnAceV2J.h : UnAceV2J.DLL ̃C wb_[ t@C
//

#pragma once

#ifdef UNACEV2J_EXPORTS
#include "resource.h"		// C V{
#endif

#if !defined(UNACEV2J_H)
#define UNACEV2J_H

#ifndef FNAME_MAX32
#define FNAME_MAX32		512
#endif

/* \̒` */
#ifndef ARC_DECSTRACT
#define ARC_DECSTRACT

#if !defined(__BORLANDC__)
#pragma pack(1)
#else
#pragma option -a-
#endif

#if !defined(__BORLANDC__) || __BORLANDC__ >= 0x550
typedef LONGLONG	ULHA_INT64;
#else
typedef struct {
	DWORD	LowPart;
	LONG	HighPart;
} ULHA_INT64, *LPULHA_INT64;
#endif

typedef	HGLOBAL	HARC;

typedef struct {
	DWORD	dwOriginalSize;
	DWORD	dwCompressedSize;
	DWORD	dwCRC;
	UINT	uFlag;
	UINT	uOSType;
	WORD	wRatio;
	WORD	wDate;
	WORD	wTime;
	char	szFileName[FNAME_MAX32 + 1];
	char	dummy1[3];
	char	szAttribute[8];
	char	szMode[8];
} INDIVIDUALINFO, FAR *LPINDIVIDUALINFO;

typedef struct {
	DWORD 			dwFileSize;
	DWORD			dwWriteSize;
	char			szSourceFileName[FNAME_MAX32 + 1];
	char			dummy1[3];
	char			szDestFileName[FNAME_MAX32 + 1];
	char			dummy[3];
}	EXTRACTINGINFO, *LPEXTRACTINGINFO;

typedef struct {
	EXTRACTINGINFO exinfo;
	DWORD dwCompressedSize;
	DWORD dwCRC;
	UINT  uOSType;
	WORD  wRatio;
	WORD  wDate;
	WORD  wTime;
	char  szAttribute[8];
	char  szMode[8];
} EXTRACTINGINFOEX, *LPEXTRACTINGINFOEX;

#if !defined(__BORLANDC__)
#pragma pack()
#else
#pragma option -a.
#endif

#endif /* ARC_DECSTRACT */

/* EBhEbZ[W */
#ifndef WM_ARCEXTRACT
#define	WM_ARCEXTRACT			"wm_arcextract"
#define	ARCEXTRACT_BEGIN		0
#define	ARCEXTRACT_INPROCESS	1
#define	ARCEXTRACT_END			2
#define ARCEXTRACT_OPEN			3
#define ARCEXTRACT_COPY			4
typedef BOOL CALLBACK ARCHIVERPROC(HWND _hwnd, UINT _uMsg, UINT _nState, LPEXTRACTINGINFOEX _lpEis);
typedef ARCHIVERPROC *LPARCHIVERPROC;
#endif

/* API̐錾 */
#ifdef __cplusplus
extern "C" {
#endif

	/* LHA.DLL݊API */
	int   WINAPI UnAce(const HWND _hwnd, LPCSTR _szCmdLine, LPSTR _szOutput, const DWORD _dwSize);
	WORD  WINAPI UnAceGetVersion();
	BOOL  WINAPI UnAceGetCursorMode();
	BOOL  WINAPI UnAceSetCursorMode(const BOOL _CursorMode);
	BOOL  WINAPI UnAceGetBackGroundMode();
	BOOL  WINAPI UnAceSetBackGroundMode(const BOOL _BackGroundMode);
	WORD  WINAPI UnAceGetCursorInterval();
	BOOL  WINAPI UnAceSetCursorInterval(const WORD _Interval);
	BOOL  WINAPI UnAceGetRunning();

	/* A[JCoAPI */
	BOOL  WINAPI UnAceConfigDialog(const HWND _hwnd, LPSTR _szOptionBuffer, const int _iMode);
	BOOL  WINAPI UnAceCheckArchive(LPCSTR _szFileName, const int _iMode);
	int   WINAPI UnAceGetFileCount(LPCSTR _szArcFile);
	BOOL  WINAPI UnAceQueryFunctionList(const int _iFunction);

	/* OpenArchivenAPI */
	HARC  WINAPI UnAceOpenArchive(const HWND _hwnd, LPCSTR _szFileName, const DWORD _dwMode);
	HARC  WINAPI UnAceOpenArchive2(const HWND _hwnd, LPCSTR _szFileName, const DWORD _dwMode, LPCSTR _szOption);
	int   WINAPI UnAceCloseArchive(HARC _harc);
	int   WINAPI UnAceFindFirst(HARC _harc, LPCSTR _szWildName, INDIVIDUALINFO *_lpSubInfo);
	int   WINAPI UnAceFindNext(HARC _harc, INDIVIDUALINFO *_lpSubInfo);
	int   WINAPI UnAceGetArcFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize);
	DWORD WINAPI UnAceGetArcFileSize(HARC _harc);
	DWORD WINAPI UnAceGetArcOriginalSize(HARC _harc);
	DWORD WINAPI UnAceGetArcCompressedSize(HARC _harc);
	WORD  WINAPI UnAceGetArcRatio(HARC _harc);
	WORD  WINAPI UnAceGetArcDate(HARC _harc);
	WORD  WINAPI UnAceGetArcTime(HARC _harc);
	UINT  WINAPI UnAceGetArcOSType(HARC _harc);
	int   WINAPI UnAceIsSFXFile(HARC _harc);
	int   WINAPI UnAceGetFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize);
	DWORD WINAPI UnAceGetOriginalSize(HARC _harc);
	DWORD WINAPI UnAceGetCompressedSize(HARC _harc);
	WORD  WINAPI UnAceGetRatio(HARC _harc);
	WORD  WINAPI UnAceGetDate(HARC _harc);
	WORD  WINAPI UnAceGetTime(HARC _harc);
	DWORD WINAPI UnAceGetCRC(HARC _harc);
	int   WINAPI UnAceGetAttribute(HARC _harc);
	UINT  WINAPI UnAceGetOSType(HARC _harc);
	int   WINAPI UnAceGetMethod(HARC _harc, LPSTR _lpBuffer, const int _nSize);
	DWORD WINAPI UnAceGetWriteTime(HARC _harc);
	DWORD WINAPI UnAceGetCreateTime(HARC _harc);
	DWORD WINAPI UnAceGetAccessTime(HARC _harc);
	BOOL  WINAPI UnAceGetWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime);
	BOOL  WINAPI UnAceGetCreateTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime);
	BOOL  WINAPI UnAceGetAccessTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime);
	BOOL  WINAPI UnAceGetArcCreateTimeEx(HARC _harc, FILETIME *_lpftCreationTime);
	BOOL  WINAPI UnAceGetArcAccessTimeEx(HARC _harc, FILETIME *_lpftLastAccessTime);
	BOOL  WINAPI UnAceGetArcWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime);
	BOOL  WINAPI UnAceGetArcFileSizeEx(HARC _harc, ULHA_INT64 *_lpllSize);
	BOOL  WINAPI UnAceGetArcOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize);
	BOOL  WINAPI UnAceGetArcCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize);
	BOOL  WINAPI UnAceGetOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize);
	BOOL  WINAPI UnAceGetCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize);

	/* SetOwnerWindownAPI */	
	BOOL WINAPI UnAceSetOwnerWindow(HWND _hwnd);
	BOOL WINAPI UnAceClearOwnerWindow();
	BOOL WINAPI UnAceSetOwnerWindowEx(HWND _hwnd, LPARCHIVERPROC _lpArcProc);
	BOOL WINAPI UnAceKillOwnerWindowEx(HWND _hwnd);

	/* UnAceV2J.DLLƎAPI */
	WORD WINAPI UnAceGetSubVersion();


#ifdef __cplusplus
}
#endif

// APIlȐl
#if !defined(ISARC_FUNCTION_START)
#define ISARC_FUNCTION_START				0
#define ISARC								0	/* UnAce */
#define ISARC_GET_VERSION					1	/* UnAceGetVersion */
#define ISARC_GET_CURSOR_INTERVAL			2	/* UnAceGetCursorInterval */
#define ISARC_SET_CURSOR_INTERVAL			3	/* UnAceSetCursorInterval */
#define ISARC_GET_BACK_GROUND_MODE			4	/* UnAceGetBackGroundMode */
#define ISARC_SET_BACK_GROUND_MODE			5	/* UnAceSetBackGroundMode */
#define ISARC_GET_CURSOR_MODE				6	/* UnAceGetCursorMode */
#define ISARC_SET_CURSOR_MODE				7	/* UnAceSetCursorMode */
#define ISARC_GET_RUNNING					8	/* UnAceGetRunning */

#define ISARC_CHECK_ARCHIVE					16	/* UnAceCheckArchive */
#define ISARC_CONFIG_DIALOG					17	/* UnAceConfigDialog */
#define ISARC_GET_FILE_COUNT				18	/* UnAceGetFileCount */
#define ISARC_QUERY_FUNCTION_LIST			19	/* UnAceQueryFunctionList */
#define ISARC_HOUT							20	/* UnAceHOut */
#define ISARC_STRUCTOUT						21	/* UnAceStructOut */
#define ISARC_GET_ARC_FILE_INFO				22	/* UnAceGetArcFileInfo */

#define ISARC_OPEN_ARCHIVE					23	/* UnAceOpenArchive */
#define ISARC_CLOSE_ARCHIVE					24	/* UnAceCloseArchive */
#define ISARC_FIND_FIRST					25	/* UnAceFindFirst */
#define ISARC_FIND_NEXT						26	/* UnAceFindNext */
#define ISARC_EXTRACT						27	/* UnAceExtract */
#define ISARC_ADD							28	/* UnAceAdd */
#define ISARC_MOVE							29	/* UnAceMove */
#define ISARC_DELETE						30	/* UnAceDelete */
#define ISARC_SETOWNERWINDOW				31	/* UnAceSetOwnerWindow */
#define ISARC_CLEAROWNERWINDOW				32	/* UnAceClearOwnerWindow */
#define ISARC_SETOWNERWINDOWEX				33	/* UnAceSetOwnerWindowEx */
#define ISARC_KILLOWNERWINDOWEX				34	/* UnAceKillOwnerWindowEx */

#define ISARC_GET_ARC_FILE_NAME				40	/* UnAceGetArcFileName */
#define ISARC_GET_ARC_FILE_SIZE				41	/* UnAceGetArcFileSize */
#define ISARC_GET_ARC_ORIGINAL_SIZE			42	/* UnAceArcOriginalSize */
#define ISARC_GET_ARC_COMPRESSED_SIZE		43	/* UnAceGetArcCompressedSize */
#define ISARC_GET_ARC_RATIO					44	/* UnAceGetArcRatio */
#define ISARC_GET_ARC_DATE					45	/* UnAceGetArcDate */
#define ISARC_GET_ARC_TIME					46	/* UnAceGetArcTime */
#define ISARC_GET_ARC_OS_TYPE				47	/* UnAceGetArcOSType */
#define ISARC_GET_ARC_IS_SFX_FILE			48	/* UnAceGetArcIsSFXFile */
#define ISARC_GET_ARC_WRITE_TIME_EX			49	/* UnAceGetArcWriteTimeEx */
#define ISARC_GET_ARC_CREATE_TIME_EX		50	/* UnAceGetArcCreateTimeEx */
#define	ISARC_GET_ARC_ACCESS_TIME_EX		51	/* UnAceGetArcAccessTimeEx */
#define	ISARC_GET_ARC_CREATE_TIME_EX2		52	/* UnAceGetArcCreateTimeEx2 */
#define ISARC_GET_ARC_WRITE_TIME_EX2		53	/* UnAceGetArcWriteTimeEx2 */
#define ISARC_GET_FILE_NAME					57	/* UnAceGetFileName */
#define ISARC_GET_ORIGINAL_SIZE				58	/* UnAceGetOriginalSize */
#define ISARC_GET_COMPRESSED_SIZE			59	/* UnAceGetCompressedSize */
#define ISARC_GET_RATIO						60	/* UnAceGetRatio */
#define ISARC_GET_DATE						61	/* UnAceGetDate */
#define ISARC_GET_TIME						62	/* UnAceGetTime */
#define ISARC_GET_CRC						63	/* UnAceGetCRC */
#define ISARC_GET_ATTRIBUTE					64	/* UnAceGetAttribute */
#define ISARC_GET_OS_TYPE					65	/* UnAceGetOSType */
#define ISARC_GET_METHOD					66	/* UnAceGetMethod */
#define ISARC_GET_WRITE_TIME				67	/* UnAceGetWriteTime */
#define ISARC_GET_CREATE_TIME				68	/* UnAceGetCreateTime */
#define ISARC_GET_ACCESS_TIME				69	/* UnAceGetAccessTime */
#define ISARC_GET_WRITE_TIME_EX				70	/* UnAceGetWriteTimeEx */
#define ISARC_GET_CREATE_TIME_EX			71	/* UnAceGetCreateTimeEx */
#define ISARC_GET_ACCESS_TIME_EX			72	/* UnAceGetAccessTimeEx */
#define ISARC_SET_ENUM_MEMBERS_PROC			80  /* UnAceSetEnumMembersProc */
#define ISARC_CLEAR_ENUM_MEMBERS_PROC		81	/* UnAceClearEnumMembersProc */
#define ISARC_GET_ARC_FILE_SIZE_EX			82	/* UnAceGetArcFileSizeEx */
#define ISARC_GET_ARC_ORIGINAL_SIZE_EX		83	/* UnAceArcOriginalSizeEx */
#define ISARC_GET_ARC_COMPRESSED_SIZE_EX	84	/* UnAceGetArcCompressedSizeEx */
#define ISARC_GET_ORIGINAL_SIZE_EX			85	/* UnAceGetOriginalSizeEx */
#define ISARC_GET_COMPRESSED_SIZE_EX		86	/* UnAceGetCompressedSizeEx */
#define ISARC_SETOWNERWINDOWEX64			87	/* UnAceSetOwnerWindowEx64 */
#define ISARC_KILLOWNERWINDOWEX64			88	/* UnAceKillOwnerWindowEx64 */
#define ISARC_SET_ENUM_MEMBERS_PROC64		89  /* UnAceSetEnumMembersProc64 */
#define ISARC_CLEAR_ENUM_MEMBERS_PROC64		90	/* UnAceClearEnumMembersProc64 */
#define ISARC_OPEN_ARCHIVE2					91	/* UnAceOpenArchive2 */
#define ISARC_GET_ARC_READ_SIZE				92	/* UnAceGetArcReadSize */
#define ISARC_GET_ARC_READ_SIZE_EX			93	/* UnAceGetArcReadSizeEx*/
#define ISARC_FUNCTION_END					ISARC_GET_ARC_READ_SIZE_EX

#endif	/* ISARC_FUNCTION_START */

// G[bZ[W
#if !defined(ERROR_START)
#define ERROR_START				0x8000
/* WARNING */
#define ERROR_DISK_SPACE		0x8005
#define ERROR_READ_ONLY			0x8006
#define ERROR_USER_SKIP			0x8007
#define ERROR_UNKNOWN_TYPE		0x8008
#define ERROR_METHOD			0x8009
#define ERROR_PASSWORD_FILE		0x800A
#define ERROR_VERSION			0x800B
#define ERROR_FILE_CRC			0x800C
#define ERROR_FILE_OPEN			0x800D
#define ERROR_MORE_FRESH		0x800E
#define ERROR_NOT_EXIST			0x800F
#define ERROR_ALREADY_EXIST		0x8010

#define ERROR_TOO_MANY_FILES	0x8011

/* ERROR */
#define ERROR_MAKEDIRECTORY		0x8012
#define ERROR_CANNOT_WRITE		0x8013
#define ERROR_HUFFMAN_CODE		0x8014
#define ERROR_COMMENT_HEADER	0x8015
#define ERROR_HEADER_CRC		0x8016
#define ERROR_HEADER_BROKEN		0x8017
#define ERROR_ARC_FILE_OPEN		0x8018
#define ERROR_NOT_ARC_FILE		0x8019
#define ERROR_CANNOT_READ		0x801A
#define ERROR_FILE_STYLE		0x801B
#define ERROR_COMMAND_NAME		0x801C
#define ERROR_MORE_HEAP_MEMORY	0x801D
#define ERROR_ENOUGH_MEMORY		0x801E
#if !defined(ERROR_ALREADY_RUNNING)
#define ERROR_ALREADY_RUNNING	0x801F
#endif
#define ERROR_USER_CANCEL		0x8020
#define ERROR_HARC_ISNOT_OPENED	0x8021
#define ERROR_NOT_SEARCH_MODE	0x8022
#define ERROR_NOT_SUPPORT		0x8023
#define ERROR_TIME_STAMP		0x8024
#define ERROR_TMP_OPEN			0x8025
#define ERROR_LONG_FILE_NAME	0x8026
#define ERROR_ARC_READ_ONLY		0x8027
#define ERROR_SAME_NAME_FILE	0x8028
#define ERROR_NOT_FIND_ARC_FILE 0x8029
#define ERROR_RESPONSE_READ		0x802A
#define ERROR_NOT_FILENAME		0x802B
#define ERROR_TMP_COPY			0x802C
#define ERROR_EOF				0x802D
#define ERROR_ADD_TO_LARC		0x802E
#define ERROR_TMP_BACK_SPACE	0x802F
#define ERROR_SHARING			0x8030
#define ERROR_NOT_FIND_FILE		0x8031
#define ERROR_LOG_FILE			0x8032
#define	ERROR_NO_DEVICE			0x8033
#define ERROR_GET_ATTRIBUTES	0x8034
#define ERROR_SET_ATTRIBUTES	0x8035
#define ERROR_GET_INFORMATION	0x8036
#define ERROR_GET_POINT			0x8037
#define ERROR_SET_POINT			0x8038
#define ERROR_CONVERT_TIME		0x8039
#define ERROR_GET_TIME			0x803a
#define ERROR_SET_TIME			0x803b
#define ERROR_CLOSE_FILE		0x803c
#define ERROR_HEAP_MEMORY		0x803d
#define ERROR_HANDLE			0x803e
#define ERROR_TIME_STAMP_RANGE	0x803f
#define ERROR_MAKE_ARCHIVE		0x8040
#define ERROR_NOT_CONFIRM_NAME	0x8041
#define ERROR_UNEXPECTED_EOF	0x8042
#define ERROR_INVALID_END_MARK	0x8043
#define ERROR_INVOLVED_LZH		0x8044
#define ERROR_NO_END_MARK		0x8045
#define ERROR_HDR_INVALID_SIZE	0x8046
#define ERROR_UNKNOWN_LEVEL		0x8047
#define ERROR_BROKEN_DATA		0x8048

#define ERROR_END	ERROR_BROKEN_DATA
#endif /* ERROR_START */

// t@C
#ifndef FA_RDONLY
#define FA_RDONLY		0x01			/* ǂݎp */
#define FA_HIDDEN		0x02			/* Bt@C */
#define FA_SYSTEM		0x04			/* VXet@C */
#define FA_LABEL		0x08			/* {[x */
#define FA_DIREC		0x10			/* fBNg */
#define FA_ARCH 		0x20			/* A[JCu */
#define FA_ENCRYPTED	0x40			/* pX[hی */
#endif /* FA_RDONLY */

#endif
