#include "StdAfx.h"
#include "ProgressDlg.h"
#include "Tools.h"
#include "resource.h"

CProgressDlg::CProgressDlg(void)
{
}


CProgressDlg::~CProgressDlg(void)
{
}

void CProgressDlg::OnCancel(UINT uNotifyCode, int nID, ATL::CWindow wndCtl) 
{
	m_Cancel = TRUE;
	EndDialog(nID);
}

void CProgressDlg::SetFileName(CString strFile)
{
	WTL::CStatic caption = GetDlgItem(IDC_CAPTION_FILE);
	caption.SetWindowText("File:"); 
	WTL::CStatic fileName = GetDlgItem(IDC_FILENAME);

	fileName.SetWindowText(CTools::OmitPath(&fileName, strFile)); 
	::UpdateWindow(m_hWnd); 
}

void CProgressDlg::SetProgressPos(UINT pos)
{
	WTL::CProgressBarCtrl progress = GetDlgItem(IDC_PROGRESS);
	progress.SetPos(pos); 
	::UpdateWindow(m_hWnd); 
}

void CProgressDlg::SetInfomation(CString strInfo)
{
	WTL::CStatic info = GetDlgItem(IDC_INFO);
	info.SetWindowText(strInfo); 
	::UpdateWindow(m_hWnd); 
}

BOOL CProgressDlg::OnInitDialog(ATL::CWindow wndFocus, LPARAM lInitParam) 
{
	m_Cancel = FALSE;
	WTL::CProgressBarCtrl progress = GetDlgItem(IDC_PROGRESS);
	progress.SetRange(0, 1000); 	
	WTL::CStatic caption = GetDlgItem(IDC_CAPTION_FILE);
	caption.SetWindowText("File:"); 
	WTL::CStatic info = GetDlgItem(IDC_INFO);
	info.SetWindowText(""); 
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

BOOL CProgressDlg::IsAbort(void)
{
	return m_Cancel;
}