// UnAceV2J.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "UnAceV2J.h"
#include "resource.h"
#include "ConfigDlg.h"
#include "Execute.h"
#include "OpenArchive.h"

int WINAPI UnAce(const HWND _hwnd, LPCSTR _szCmdLine, LPSTR _szOutput, const DWORD _dwSize)
{
	BOOL bLocked = FALSE;
	if (_hwnd != NULL && ::IsWindow(_hwnd) && ::IsWindowEnabled(_hwnd)) { 
		::EnableWindow(_hwnd, FALSE);
		bLocked = TRUE;
	}

	CExecute exec(_hwnd);
	CString strCmdLine = _szCmdLine;

	DWORD dwResult = exec.SetCommand(strCmdLine);
	CString strOut = exec.GetOutput(); 

	if (_szOutput != NULL) {
		strncpy_s(_szOutput, _dwSize, strOut, _TRUNCATE);
	}

	if (bLocked) {
		::EnableWindow(_hwnd, TRUE);
		::BringWindowToTop(_hwnd); 
	}
	return dwResult;
}

WORD WINAPI UnAceGetVersion()
{
	WORD ver;
	VS_FIXEDFILEINFO *verinfo;
	HRSRC res;
	HGLOBAL hres;
	HINSTANCE dll_instance = _Module.GetResourceInstance(); //AfxGetResourceHandle();

	res = FindResource(dll_instance, MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	hres = LoadResource(dll_instance, res);
	verinfo = (VS_FIXEDFILEINFO *)((char *)LockResource(hres) + 40);
	ver = (WORD)((verinfo->dwFileVersionMS >> 16) * 100 + (verinfo->dwFileVersionMS & 0xffff));
	return ver;
}

// {IɈӖȂ
BOOL WINAPI UnAceGetCursorMode() { return _Module.g_CursorMode; }
BOOL WINAPI UnAceSetCursorMode(const BOOL _CursorMode) { _Module.g_CursorMode = _CursorMode; return TRUE; }
BOOL WINAPI UnAceGetBackGroundMode() { return _Module.g_BackGroundMode; }
BOOL WINAPI UnAceSetBackGroundMode(const BOOL _BackGroundMode) { _Module.g_BackGroundMode = _BackGroundMode; return TRUE; }
WORD WINAPI UnAceGetCursorInterval() { return _Module.g_CursorInterval; }
BOOL WINAPI UnAceSetCursorInterval(const WORD _Interval) { _Module.g_CursorInterval = _Interval; return TRUE; }

BOOL WINAPI UnAceGetRunning()
{
	return _Module.g_Running;
}

BOOL WINAPI UnAceConfigDialog(const HWND _hwnd, LPSTR _szOptionBuffer, const int _iMode)
{
	if (UnAceGetRunning())
		return FALSE;
	CConfigDlg dlg;
	CString s;
	s.Format("UnAceV2J.DLL Version %d.%.2d.%.2d.%.2d", 
					UnAceGetVersion() / 100, 
					UnAceGetVersion() % 100,
					UnAceGetSubVersion() / 100,
					UnAceGetSubVersion() % 100);
	dlg.m_Version = s;
	dlg.m_Copyright = "Copyright (C) 2004-2010 Niiyama(HEROPA)";
	return (dlg.DoModal() == IDOK); 
}

BOOL WINAPI UnAceCheckArchive(LPCSTR _szFileName, const int _iMode)
{
	if (UnAceGetRunning())
		return FALSE;
	CExecute exec;
	return exec.CheckArchive(_szFileName); 
}

int WINAPI UnAceGetFileCount(LPCSTR _szArcFile)
{
	if (UnAceGetRunning())
		return FALSE;
	CExecute exec;
	return exec.GetFileCount(_szArcFile);
}

BOOL WINAPI UnAceQueryFunctionList(const int _iFunction)
{
	switch (_iFunction) {
	case ISARC:
	case ISARC_GET_VERSION:
	case ISARC_GET_CURSOR_INTERVAL:
	case ISARC_SET_CURSOR_INTERVAL:
	case ISARC_GET_BACK_GROUND_MODE:
	case ISARC_SET_BACK_GROUND_MODE:
	case ISARC_GET_CURSOR_MODE:
	case ISARC_SET_CURSOR_MODE:
	case ISARC_GET_RUNNING:
		
	case ISARC_CHECK_ARCHIVE:
	case ISARC_CONFIG_DIALOG:
	case ISARC_GET_FILE_COUNT:
	case ISARC_QUERY_FUNCTION_LIST:
//	case ISARC_HOUT:
//	case ISARC_STRUCTOUT:
//	case ISARC_GET_ARC_FILE_INFO:
		
	case ISARC_OPEN_ARCHIVE:
	case ISARC_CLOSE_ARCHIVE:
	case ISARC_FIND_FIRST:
	case ISARC_FIND_NEXT:
//	case ISARC_EXTRACT:
//	case ISARC_ADD:
//	case ISARC_MOVE:
//	case ISARC_DELETE:
//	case ISARC_SETOWNERWINDOW:
//	case ISARC_CLEAROWNERWINDOW:
//	case ISARC_SETOWNERWINDOWEX:
//	case ISARC_KILLOWNERWINDOWEX:
		
	case ISARC_GET_ARC_FILE_NAME:
	case ISARC_GET_ARC_FILE_SIZE:
	case ISARC_GET_ARC_ORIGINAL_SIZE:
	case ISARC_GET_ARC_COMPRESSED_SIZE:
	case ISARC_GET_ARC_RATIO:
	case ISARC_GET_ARC_DATE:
	case ISARC_GET_ARC_TIME:
	case ISARC_GET_ARC_OS_TYPE:
//	case ISARC_GET_ARC_IS_SFX_FILE:
	case ISARC_GET_ARC_WRITE_TIME_EX:
	case ISARC_GET_ARC_CREATE_TIME_EX:
	case ISARC_GET_ARC_ACCESS_TIME_EX:
	case ISARC_GET_ARC_CREATE_TIME_EX2:
	case ISARC_GET_ARC_WRITE_TIME_EX2:
	case ISARC_GET_FILE_NAME:
	case ISARC_GET_ORIGINAL_SIZE:
	case ISARC_GET_COMPRESSED_SIZE:
	case ISARC_GET_RATIO:
	case ISARC_GET_DATE:
	case ISARC_GET_TIME:
	case ISARC_GET_CRC:
	case ISARC_GET_ATTRIBUTE:
//	case ISARC_GET_OS_TYPE:
	case ISARC_GET_METHOD:
	case ISARC_GET_WRITE_TIME:
	case ISARC_GET_CREATE_TIME:
	case ISARC_GET_ACCESS_TIME:
	case ISARC_GET_WRITE_TIME_EX:
	case ISARC_GET_CREATE_TIME_EX:
	case ISARC_GET_ACCESS_TIME_EX:
//	case ISARC_SET_ENUM_MEMBERS_PROC:
//	case ISARC_CLEAR_ENUM_MEMBERS_PROC:
	case ISARC_GET_ARC_FILE_SIZE_EX:
	case ISARC_GET_ARC_ORIGINAL_SIZE_EX:
	case ISARC_GET_ARC_COMPRESSED_SIZE_EX:
	case ISARC_GET_ORIGINAL_SIZE_EX:
	case ISARC_GET_COMPRESSED_SIZE_EX:
//	case ISARC_SETOWNERWINDOWEX64:
//	case ISARC_KILLOWNERWINDOWEX64:
//	case ISARC_SET_ENUM_MEMBERS_PROC64:
//	case ISARC_CLEAR_ENUM_MEMBERS_PROC64:
	case ISARC_OPEN_ARCHIVE2:
//	case ISARC_GET_ARC_READ_SIZE:
//	case ISARC_GET_ARC_READ_SIZE_EX:
		return TRUE;
	default:
		break;
	}
	return FALSE;
}

HARC WINAPI UnAceOpenArchive(const HWND _hwnd, LPCSTR _szFileName, const DWORD _dwMode)
{
	COpenArchive* pOpenArchive = new COpenArchive;
	if (pOpenArchive) {
		if (pOpenArchive->Open(_hwnd, _szFileName, _dwMode) == FALSE) {
			delete pOpenArchive;
			return NULL;
		}
	}
	return (HARC)pOpenArchive;
}

HARC  WINAPI UnAceOpenArchive2(const HWND _hwnd, LPCSTR _szFileName, const DWORD _dwMode, LPCSTR _szOption)
{
	// _szOption͖B
	return UnAceOpenArchive(_hwnd, _szFileName, _dwMode);
}

int WINAPI UnAceCloseArchive(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	pOpenArchive->Close(); 
	delete pOpenArchive;
	return 0;
}

int WINAPI UnAceFindFirst(HARC _harc, LPCSTR _szWildName, INDIVIDUALINFO *_lpSubInfo)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->FindFirst(_szWildName, _lpSubInfo);
}

int WINAPI UnAceFindNext(HARC _harc, INDIVIDUALINFO *_lpSubInfo)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_NOT_SEARCH_MODE;
	return pOpenArchive->FindNext(_lpSubInfo);
}

int WINAPI UnAceGetArcFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetArcFileName(_lpBuffer, _nSize);
}

DWORD WINAPI UnAceGetArcFileSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcFileSize();
}

DWORD WINAPI UnAceGetArcOriginalSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcOriginalSize();
}

DWORD WINAPI UnAceGetArcCompressedSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcCompressedSize();
}

WORD WINAPI UnAceGetArcRatio(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcRatio();
}

WORD WINAPI UnAceGetArcDate(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcDate();
}

WORD WINAPI UnAceGetArcTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcTime();
}

// Gĝ݁BG[ȊOAK0Ԃ
UINT WINAPI UnAceGetArcOSType(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetArcOSType();
}

// Gĝ݁BG[ȊOAK0Ԃ
int WINAPI UnAceIsSFXFile(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->IsSFXFile();
}

int WINAPI UnAceGetFileName(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetFileName(_lpBuffer, _nSize);
}

DWORD WINAPI UnAceGetOriginalSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetOriginalSize();
}

DWORD WINAPI UnAceGetCompressedSize(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCompressedSize();
}

WORD WINAPI UnAceGetRatio(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetRatio();
}

WORD WINAPI UnAceGetDate(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetDate();
}

WORD WINAPI UnAceGetTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetTime();
}

DWORD WINAPI UnAceGetCRC(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCRC();
}

int WINAPI UnAceGetAttribute(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAttribute();
}

// Gĝ݁BG[ȊOAK0Ԃ
UINT WINAPI UnAceGetOSType(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetOSType();
}

int WINAPI UnAceGetMethod(HARC _harc, LPSTR _lpBuffer, const int _nSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return ERROR_HARC_ISNOT_OPENED;
	return pOpenArchive->GetMethod(_lpBuffer, _nSize);
}

DWORD WINAPI UnAceGetWriteTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetWriteTime();
}

DWORD WINAPI UnAceGetCreateTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCreateTime();
}

DWORD WINAPI UnAceGetAccessTime(HARC _harc)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAccessTime();
}

BOOL WINAPI UnAceGetWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetWriteTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI UnAceGetCreateTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetCreateTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI UnAceGetAccessTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return -1;
	return pOpenArchive->GetAccessTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI UnAceGetArcCreateTimeEx(HARC _harc, FILETIME *_lpftCreationTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcCreateTimeEx(_lpftCreationTime);
}

BOOL WINAPI UnAceGetArcAccessTimeEx(HARC _harc, FILETIME *_lpftLastAccessTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcAccessTimeEx(_lpftLastAccessTime);
}

BOOL WINAPI UnAceGetArcWriteTimeEx(HARC _harc, FILETIME *_lpftLastWriteTime)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcWriteTimeEx(_lpftLastWriteTime);
}

BOOL WINAPI UnAceGetArcFileSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcFileSizeEx(_lpllSize);
}

BOOL WINAPI UnAceGetArcOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcOriginalSizeEx(_lpllSize);
}

BOOL WINAPI UnAceGetArcCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetArcCompressedSizeEx(_lpllSize);
}

BOOL WINAPI UnAceGetOriginalSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetOriginalSizeEx(_lpllSize);
}

BOOL  WINAPI UnAceGetCompressedSizeEx(HARC _harc, ULHA_INT64 *_lpllSize)
{
	COpenArchive* pOpenArchive = COpenArchive::FindObject(_harc);
	if (pOpenArchive == NULL)
		return FALSE;
	return pOpenArchive->GetCompressedSizeEx(_lpllSize);
}

BOOL WINAPI UnAceSetOwnerWindow(HWND _hwnd)
{
	return FALSE;	//CProgressDialog::SetOwnerWindow(_hwnd);
}

BOOL WINAPI UnAceClearOwnerWindow()
{
	return FALSE;	//CProgressDialog::ClearOwnerWindow();
}

BOOL WINAPI UnAceSetOwnerWindowEx(HWND _hwnd, LPARCHIVERPROC _lpArcProc)
{
	return FALSE;	//CProgressDialog::SetOwnerWindowEx(_hwnd, _lpArcProc);
}

BOOL WINAPI UnAceKillOwnerWindowEx(HWND _hwnd)
{
	return FALSE;	//CProgressDialog::KillOwnerWindowEx(_hwnd);
}

WORD WINAPI UnAceGetSubVersion()
{
	WORD ver;
	VS_FIXEDFILEINFO *verinfo;
	HRSRC res;
	HGLOBAL hres;
	HINSTANCE dll_instance = _Module.GetResourceInstance();	// AfxGetResourceHandle();

	res = FindResource(dll_instance, MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	hres = LoadResource(dll_instance, res);
	verinfo = (VS_FIXEDFILEINFO *)((char *)LockResource(hres) + 40);
	ver = (WORD)((verinfo->dwFileVersionLS >> 16) * 100 + (verinfo->dwFileVersionLS & 0xffff));
	return ver;
}

