#pragma once

#include "stdafx.h"
#include "UnAceV2J.h"

class CArchiveFileInfo
{
public:
	CArchiveFileInfo(void);
	~CArchiveFileInfo(void);
	void SetFilename(CString strFileName);
	CString GetFilename(void);
	void SetLength(DWORDLONG dwlLength);
	ULHA_INT64 GetLength(void);
	void SetCompressedLength(DWORDLONG dwlCompressedLength);
	ULHA_INT64 GetCompressedLength(void);
	void SetAttr(ULONG ulAttr);
	DWORD GetAttr(void);
	void SetCreationDateTime(ULONG ulTime);
	FILETIME GetCreationDateTime(void);
	void SetModificationDateTime(ULONG ulTime);
	FILETIME GetModificationDateTime(void);
	void SetLastAccessDateTime(ULONG ulTime);
	FILETIME GetLastAccessDateTime(void);
	void SetCRC32(ULONG ulCRC32);
	DWORD GetCRC32(void);
	void SetMethod(ULONG ulMethod);
	CString GetMethod(void);

private:
	CString			m_Filename;
	ULHA_INT64		m_Length;
	ULHA_INT64		m_CompressedLength;
	DWORD			m_Attributes;
	COleDateTime	m_CreationDateTime;
	COleDateTime	m_ModificationDateTime;
	COleDateTime	m_LastAccessDateTime;
	DWORD			m_CRC32;
	CString			m_Method;

};

