#pragma once

#include "stdafx.h"
#include "resource.h"

class CConfigDlg : public CDialogImpl<CConfigDlg>, public WTL::CWinDataExchange<CConfigDlg>
{
public:
	enum { IDD = IDD_CONFIG };

	WTL::CString m_Version;
	WTL::CString m_Copyright;

	BEGIN_DDX_MAP(CConfigDlg)
        DDX_TEXT(IDC_VERSION, m_Version)
		DDX_TEXT(IDC_COPYRIGHT, m_Copyright)
	END_DDX_MAP()

	BEGIN_MSG_MAP(CConfigDlg)
        MSG_WM_INITDIALOG(OnInitDialog)
        COMMAND_ID_HANDLER_EX(IDOK, OnOK)
        COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

	CConfigDlg(void);
	~CConfigDlg(void);

    BOOL OnInitDialog(ATL::CWindow wndFocus, LPARAM lInitParam);

	void OnOK(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);

    void OnCancel(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);

};

