#include "StdAfx.h"
#include "UnAceV2J.h"
#include "Confirmation.h"
#include "Tools.h"
#include <shellapi.h>
#pragma comment(lib,"shlwapi.lib")

CConfirmation::CConfirmation(void)
{
}


CConfirmation::~CConfirmation(void)
{
}

BOOL CConfirmation::OnInitDialog(CWindow wndFocus, LPARAM lInitParam){
    // XN[̒ɔzu
    CenterWindow();

    // Rg[ݒ
    DoDataExchange(FALSE);

	HICON hIcon = ::LoadIcon(NULL, IDI_QUESTION);
	::SendMessage(::GetDlgItem(m_hWnd, IDS_REPLACE), STM_SETICON, (WPARAM)hIcon, 0);

	FILETIME ftLocal;
	SYSTEMTIME stWrite;
	CString strFormat;
	SHFILEINFO shFileInfo;
	WIN32_FIND_DATA wfd;

	::DosDateTimeToFileTime(HIWORD(m_NewTime), LOWORD(m_NewTime), &ftLocal); 
	::FileTimeToSystemTime(&ftLocal, &stWrite);
	WTL::CStatic lblNewFileInfo = GetDlgItem(IDS_NEW_FILE_INFO);
	lblNewFileInfo.GetWindowText(strFormat);
	CString s;
	s.Format(strFormat, CTools::OmitPath(&lblNewFileInfo, m_NewName),
						stWrite.wYear, 
						stWrite.wMonth, 
						stWrite.wDay, 
						stWrite.wHour, 
						stWrite.wMinute, 
						stWrite.wSecond, 
						m_NewSize);
	lblNewFileInfo.SetWindowText(s);
	::SHGetFileInfo(m_NewName, 
					FILE_ATTRIBUTE_NORMAL, 
					&shFileInfo, 
					sizeof(shFileInfo), 
					SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
	::SendMessage(::GetDlgItem(m_hWnd, IDS_NEW_ICON), 
					STM_SETICON, 
					(WPARAM)(shFileInfo.hIcon), 
					0);

	WTL::CStatic lblOldFileInfo = GetDlgItem(IDS_OLD_FILE_INFO);
	HANDLE hFind = ::FindFirstFile(m_OldName, &wfd);
	::FindClose(hFind); 
	::FileTimeToLocalFileTime(&wfd.ftLastWriteTime, &ftLocal);
	::FileTimeToSystemTime(&ftLocal, &stWrite);
	s.Format(strFormat, CTools::OmitPath(&lblOldFileInfo, m_OldName),
						stWrite.wYear, 
						stWrite.wMonth, 
						stWrite.wDay, 
						stWrite.wHour, 
						stWrite.wMinute, 
						stWrite.wSecond, 
						m_NewSize);
	lblOldFileInfo.SetWindowText(s); 
	::SHGetFileInfo(m_OldName, 
					FILE_ATTRIBUTE_NORMAL, 
					&shFileInfo, 
					sizeof(shFileInfo), 
					SHGFI_ICON | SHGFI_USEFILEATTRIBUTES | SHGFI_LARGEICON);
	::SendMessage(::GetDlgItem(m_hWnd, IDS_OLD_ICON), 
					STM_SETICON, 
					(WPARAM)(shFileInfo.hIcon), 
					0);

	return TRUE;
}

int CConfirmation::DoModal() 
{
	CDialogImpl::DoModal();
	return m_Result;
}

void CConfirmation::SetFileInfo(CString strNewName, DWORDLONG dwlNewSize, ULONG ulNewTime, CString strOldName)
{
//	TRACE("SetFileInfo(%s, %d, %d, %s)\n", strNewName, dwlNewSize, ulNewTime, strOldName);
	m_NewName = strNewName;
	m_NewSize = dwlNewSize;
	m_NewTime = ulNewTime;
	m_OldName = strOldName;
}

void CConfirmation::OnNo(UINT uNotifyCode, int nID, ATL::CWindow wndCtl)
{
	m_Result = IDB_NO;
	EndDialog(nID);
}
void CConfirmation::OnNoAll(UINT uNotifyCode, int nID, ATL::CWindow wndCtl)
{
	m_Result = IDB_NO_ALL;
	EndDialog(nID);
}

void CConfirmation::OnYes(UINT uNotifyCode, int nID, ATL::CWindow wndCtl)
{
	m_Result = IDB_YES;
	EndDialog(nID);
}

void CConfirmation::OnYesAll(UINT uNotifyCode, int nID, ATL::CWindow wndCtl)
{
	m_Result = IDB_YES_ALL;
	EndDialog(nID);
}

void CConfirmation::OnCancel(UINT uNotifyCode, int nID, ATL::CWindow wndCtl)
{
	m_Result = IDCANCEL;
	EndDialog(nID);
}
