#pragma once

#include "stdafx.h"
#include "resource.h"

class CProgressDlg : public CDialogImpl<CProgressDlg>, public WTL::CWinDataExchange<CProgressDlg>
{
public:
	enum { IDD = IDD_PROGRESS };
	
	BEGIN_MSG_MAP(CProgressDlg)
        MSG_WM_INITDIALOG(OnInitDialog)
        COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
	END_MSG_MAP()

	CProgressDlg(void);
	~CProgressDlg(void);

    BOOL OnInitDialog(ATL::CWindow wndFocus, LPARAM lInitParam);

    void OnCancel(UINT uNotifyCode, int nID, ATL::CWindow wndCtl);

	void SetInfomation(CString strInfo);
	void SetProgressPos(UINT pos);
	void SetFileName(CString strFile);
	BOOL IsAbort(void);
private:
	BOOL m_Cancel;

};

